/* File:      flora.P
** Author(s): Michael Kifer, Guizhen Yang
** Contact:   xsb-contact@cs.sunysb.edu
** 
** Copyright (C) The Research Foundation of SUNY, 1998
** 
** XSB is free software; you can redistribute it and/or modify it under the
** terms of the GNU Library General Public License as published by the Free
** Software Foundation; either version 2 of the License, or (at your option)
** any later version.
** 
** XSB is distributed in the hope that it will be useful, but WITHOUT ANY
** WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
** FOR A PARTICULAR PURPOSE.  See the GNU Library General Public License for
** more details.
** 
** You should have received a copy of the GNU Library General Public License
** along with XSB; if not, write to the Free Software Foundation,
** Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
**
** 
*/

:- compiler_options([xpp_on]).

#mode save
#mode nostring "\!#'"
#define STD_FPREFIX(X)    '_$_$_flora_''X'
#mode restore

%% bootstrap(package-dirname-as-string, package-name-as-symbol).
%% This also asserts 
%% package_configuration(dir(PackageName), FullPackageDirname)
%% some packages use it.

:- import bootstrap_package/2, package_configuration/2 from packaging.
:- import STD_FPREFIX(shell)/0 from usermod.
:- import hide_this_show/2 from usermod.
:- import slash/1 from machine.
:- import trie_assert/1 from tables.
:- import conget/2 from gensym.
:- import xpp_include_dir/1 from parse.
:- dynamic hide_this_show(_,_).

:- export bootstrap_flora1/0, flora_shell1/0.


%% bootstrap_package fails, if Flora is already loaded.
%% Then bootstrap_flora quietly succeeds without 
%% so that package_configuration won''t be asserted twice.
bootstrap_flora1 :-
	bootstrap_package([flora,lib,syslib,pkgs,p2h],flora),
	!,
	assert(package_configuration(version(flora),'0.94 of 1999/11/21')),
	package_configuration(dir(flora),FlDir),
	slash(S),
	fmt_write_string(FloraIncludeDir, '%s%sincludes', args(FlDir,S)),
	assert(xpp_include_dir(FloraIncludeDir)),
	fmt_write_string(LibFlrDisplay,'%s%ssyslib%sflrdisplay',
			 f(FlDir,S,S)),
	[tables, LibFlrDisplay, flrutils, p2h_config].
bootstrap_flora1.

%% don''t show flora_shell in trace
:- trie_assert(hide_this_show(flora_shell1,0)). 

flora_shell1 :- notrace,  %% stop any tracing
	(   conget(flora_shell_loaded, 1), !
	;   bootstrap_flora1,
	    [flrshell],
	    STD_FPREFIX(shell)
	).
