/**** closure/flrheader.P: Prepended automatically by the FLORA compiler ****/

:- compiler_options([xpp_on]).
#include "standard.h"
#include "char_defs.h"

#define  VAR_FPREFIX_BASE  dyn_$_$_flora_
#include "flora_prefix.h"


:- import member/2, ground/1 from basics.

:- import consult/1 from consult.

:- import slash/1 from machine.

:- import fmt_write_string/3 from file_io.

:- import current_predicate/1 from curr_sym.

:- import STD_FPREFIX(loadlist)/1, STD_FPREFIX(dynloadlist)/1, 
	STD_FPREFIX(warning_nl)/2
   from flrutils.

:- import bootstrap_flora1/0 from flora.


/****************************************************************************/
:- dynamic VAR_FPREFIX(fd)(_,_,_).
:- dynamic VAR_FPREFIX(mvd)(_,_,_).
:- dynamic VAR_FPREFIX(ifd)(_,_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_,_).
:- dynamic VAR_FPREFIX(isa)(_,_).
:- dynamic VAR_FPREFIX(sub)(_,_).
:- dynamic VAR_FPREFIX(fs)(_,_,_).
:- dynamic VAR_FPREFIX(mvs)(_,_,_).
:- dynamic VAR_FPREFIX(exists)(_).
:- dynamic VAR_FPREFIX(mvd)(_,_).
:- dynamic VAR_FPREFIX(imvd)(_,_).

:- table STD_FPREFIX(fd)/3.
:- table STD_FPREFIX(mvd)/3.
:- table STD_FPREFIX(ifd)/3.
:- table STD_FPREFIX(imvd)/3.
:- table STD_FPREFIX(isa)/2.
:- table STD_FPREFIX(sub)/2.
:- table STD_FPREFIX(fs)/3.
:- table STD_FPREFIX(mvs)/3.

:- table VAR_FPREFIX(fd)/3.
:- table VAR_FPREFIX(mvd)/3.
:- table VAR_FPREFIX(ifd)/3.
:- table VAR_FPREFIX(imvd)/3.
:- table VAR_FPREFIX(isa)/2.
:- table VAR_FPREFIX(sub)/2.
:- table VAR_FPREFIX(fs)/3.
:- table VAR_FPREFIX(mvs)/3.
:- table VAR_FPREFIX(exists)/1.
:- table VAR_FPREFIX(mvd)/2.
:- table VAR_FPREFIX(imvd)/2.

STD_FPREFIX(fd)(O,M,R)   :- VAR_FPREFIX(fd)(O,M,R).
STD_FPREFIX(mvd)(O,M,R)  :- VAR_FPREFIX(mvd)(O,M,R).
STD_FPREFIX(ifd)(O,M,R)  :- VAR_FPREFIX(ifd)(O,M,R).
STD_FPREFIX(imvd)(O,M,R) :- VAR_FPREFIX(imvd)(O,M,R).
STD_FPREFIX(isa)(O1,O2)  :- VAR_FPREFIX(isa)(O1,O2).
STD_FPREFIX(sub)(O1,O2)  :- VAR_FPREFIX(sub)(O1,O2).
STD_FPREFIX(fs)(O,M,R)   :- VAR_FPREFIX(fs)(O,M,R).
STD_FPREFIX(mvs)(O,M,R)  :- VAR_FPREFIX(mvs)(O,M,R).
STD_FPREFIX(exists)(O)   :- VAR_FPREFIX(exists)(O).
STD_FPREFIX(mvd)(O,M)    :- VAR_FPREFIX(mvd)(O,M).
STD_FPREFIX(imvd)(O,M)   :- VAR_FPREFIX(imvd)(O,M).


/****************************************************************************/
STD_FPREFIX(tag)(noquery).

?- STD_FPREFIX(tag)(query), !,
   (   current_predicate(STD_FPREFIX(print_all)/2)
   ;   bootstrap_flora1
   ),
   !.


#undef VAR_FPREFIX_BASE

/************************** End of Header ***********************************/

